(function webpackUniversalModuleDefinition(root, factory) {
	if(typeof exports === 'object' && typeof module === 'object')
		module.exports = factory(require("React"));
	else if(typeof define === 'function' && define.amd)
		define(["React"], factory);
	else if(typeof exports === 'object')
		exports["ReactMultiSelect"] = factory(require("React"));
	else
		root["ReactMultiSelect"] = factory(root["React"]);
})(this, function(__WEBPACK_EXTERNAL_MODULE_1__) {
return /******/ (function(modules) { // webpackBootstrap
/******/ 	// The module cache
/******/ 	var installedModules = {};
/******/
/******/ 	// The require function
/******/ 	function __webpack_require__(moduleId) {
/******/
/******/ 		// Check if module is in cache
/******/ 		if(installedModules[moduleId])
/******/ 			return installedModules[moduleId].exports;
/******/
/******/ 		// Create a new module (and put it into the cache)
/******/ 		var module = installedModules[moduleId] = {
/******/ 			exports: {},
/******/ 			id: moduleId,
/******/ 			loaded: false
/******/ 		};
/******/
/******/ 		// Execute the module function
/******/ 		modules[moduleId].call(module.exports, module, module.exports, __webpack_require__);
/******/
/******/ 		// Flag the module as loaded
/******/ 		module.loaded = true;
/******/
/******/ 		// Return the exports of the module
/******/ 		return module.exports;
/******/ 	}
/******/
/******/
/******/ 	// expose the modules object (__webpack_modules__)
/******/ 	__webpack_require__.m = modules;
/******/
/******/ 	// expose the module cache
/******/ 	__webpack_require__.c = installedModules;
/******/
/******/ 	// __webpack_public_path__
/******/ 	__webpack_require__.p = "";
/******/
/******/ 	// Load entry module and return exports
/******/ 	return __webpack_require__(0);
/******/ })
/************************************************************************/
/******/ ([
/* 0 */
/***/ function(module, exports, __webpack_require__) {

	/** @jsx React.DOM */'use strict';

	var React = __webpack_require__(1)
	var TagField = __webpack_require__(2)

	module.exports = React.createClass({

		displayName: 'ReactMultiSelect',

		render: function(){

		}
	})

/***/ },
/* 1 */
/***/ function(module, exports, __webpack_require__) {

	module.exports = __WEBPACK_EXTERNAL_MODULE_1__;

/***/ },
/* 2 */
/***/ function(module, exports, __webpack_require__) {

	/** @jsx React.DOM */'use strict';

	var React     = __webpack_require__(1)
	var Field     = __webpack_require__(8)
	var assign    = __webpack_require__(6)
	var normalize = __webpack_require__(7)

	var getSelectionStart = __webpack_require__(3)
	var getSelectionEnd   = __webpack_require__(4)
	var setSelectionRange = __webpack_require__(5)

	function emptyFn(){}
	function preventDefault(event){ event.preventDefault() }

	function insert(target, index, what){

		if (index == -1){
			return target.concat(what)
		}

		return target.slice(0, index)
				.concat(what)
				.concat(target.slice(index))
	}

	module.exports = React.createClass({

		displayName: 'ReactTagField',

		getSelectionStart: function() {
			return getSelectionStart(this.refs.field.getInput())
		},

		getSelectionEnd: function() {
			return getSelectionEnd(this.refs.field.getInput())
		},

		setSelectionRange: function(range, input) {
			var start = range.start
			var end   = range.end

			setSelectionRange(input || this.refs.field.getInput(), range)
		},

		getDefaultProps: function() {
			return {
				minInputSize: 3,

				selectedTagStyle: {
					background: 'rgb(200, 200, 200)'
				},
				focusOnClick: true,
				selectableTags: false,

				clearTool: false,
				tagOnBlur: false,
				tagClearTool: false,
				allowDuplicates: false,
				editableTags: true,
				delimiter: ' ',

				tagClearToolColor: '#a8a8a8',

				defaultStyle: {
					overflow: 'hidden'
				},

				defaultInputStyle: {
					flex: 'none',
					alignSelf: 'center'
				},

				defaultInnerStyle: {
				    display   : 'inline-flex',
				    flexFlow  : 'row wrap'
				},

				defaultTagStyle: {
					display     : 'inline-flex',
					boxSizing: 'border-box',
					alignItems  : 'center',
					flex: 'none',
					flexFlow    : 'row',
					padding: '6px 2px',
					marginLeft  : 2,
					marginTop  : 1,
					marginBottom  : 1,
					border      : '1px solid gray',
					overflow    : 'hidden',
					whiteSpace  : 'nowrap'
				},

				defaultTagClearToolStyle: {
					cursor: 'pointer'
				},

				validateTag: function(x){
					return x !== '' && x != null
				}
			}
		},

		getInitialState: function(){
		    return {
				defaultValue  : this.props.defaultValue,
				defaultTags   : this.props.defaultTags,
				activeTagIndex: -1
		    }
		},

		getValue: function() {
		    var value = this.props.value === undefined?
		                    this.state.defaultValue:
		                    this.props.value

		    return value
		},

		render: function() {

			var props     = this.prepareProps(this.props, this.state)
			var inputSize = Math.max(props.value? props.value.length: 0, this.props.minInputSize)

			return React.createElement(Field, React.__spread({ref: "field"},  props, {inputProps: {size: inputSize}}))
		},

		getInfoForValue: function(value, propsTags) {
			var props          = this.props
			var state          = this.state
			var activeTagIndex = state.activeTagIndex

			var tags     = value.split(props.delimiter)
			var newValue = tags[tags.length - 1]
			var tagMap   = {}

		    if (!props.allowDuplicates){
		    	propsTags = propsTags || this.prepareTags(this.props)

			    propsTags.forEach(function(tag, index){
			    	if (index != activeTagIndex){
				    	tagMap[tag] = true
				    }
			    })
			}

		    tags = tags.slice(0, tags.length - 1).filter(function(x){
		    	return x && !tagMap[x]
		    })

		    return {
				tags : tags,
				value: newValue
		    }

		},

		handleClick: function(props, event) {

			if (!event.nativeEvent.tagClick && props.selectableTags){
				this.setState({
					activeTagIndex: -1
				})

				this.focus()
			}

			if (!props.selectableTags){
				this.props.focusOnClick && this.focus()
			}

			;(this.props.onClick || emptyFn)(event)
		},

		handleBlur: function(props, event) {
			if (props.tagOnBlur && props.validateTag(props.value)){
				this.handleChange(props, props.value + props.delimiter, null, event)
			}

			;(this.props.onBlur || emptyFn)(event)
		},

		handleChange: function(props, value, inputProps, event){
			var state   = this.state
			var info    = this.getInfoForValue(value, props.tags)
			var newTags = info.tags

			var allTags = props.editableTags?
							insert(props.tags, state.activeTagIndex, newTags):
							[].concat(props.tags).concat(newTags)

			if (newTags.length && state.activeTagIndex != -1 && props.editableTags){
				this.setState({
					activeTagIndex: state.activeTagIndex + 1
				})
			}

			this.notifyChange(props, info.value, allTags, event)
		},

		notifyChange: function(props, newValue, allTags, event) {

			var newState = {}

	    	;(this.props.onChangeTags || emptyFn)(allTags)

	    	if (this.props.tags == null){
	    	    newState.defaultTags = allTags
	    	}

		    if (this.props.value == null){
		    	newState.defaultValue = newValue
		    }

		    this.setState(newState)

		    ;(this.props.onChange || emptyFn)(newValue, this.props, event)
		},

		handleKeyDown: function(props, event) {

			var key = event.key

			if (this.props.onKeyDown){
				this.props.onKeyDown(event)
			}

			if (!props.tags.length){
				return
			}

			if (key != 'Backspace' && key != 'ArrowLeft' && key != 'ArrowRight' && key != 'Delete'){
				return
			}

			var value = props.value + ''
			var index = this.state.activeTagIndex
			var tags  = props.tags

			var textToLeft
			var textToRight

			var selectionStart = this.getSelectionStart()
			var selectionEnd   = this.getSelectionEnd()

			if (selectionStart < selectionEnd){
				return
			}

			if (key == 'ArrowLeft' || key == 'Backspace'){
				textToLeft = value.substring(0, selectionStart)
			}

			if (key == 'ArrowRight' || key == 'Delete'){
				textToRight = value.substring(selectionEnd)
			}

			if ((key == 'Backspace' || key == 'ArrowLeft') && textToLeft === ''){

				//if there is no other character at the left of the cursor,
				//go to the tag before the cursor

				if (index == -1){
					index = tags.length
				}

				index--

				if (index >= 0){
					if (props.selectableTags){
						this.focusHidden()
					}
					this.setActiveTagIndex(props, index)
					event.preventDefault()
				}
			}

			if ((key == 'ArrowRight' || key == 'Delete') && textToRight == '' && tags[index]){
				event.preventDefault()
				this.setActiveTagIndex(props, index, function(){
					this.setSelectionRange({start: 0, end: 0})
				}.bind(this))
			}
		},

		removeTag: function(props, index) {
			var allTags = this.tags.filter(function(tag, i){
				return i !== index
			})

			var activeTagIndex = this.state.activeTagIndex
			if (activeTagIndex != -1 && activeTagIndex > index){
				//an item was removed from before the editing tag
				//so bring the editing index one down
				this.setState({
					activeTagIndex: activeTagIndex - 1
				})
			}

			this.notifyChange(props, props.value, allTags)
		},

		setActiveTagIndex: function(props, index, callback) {
			var currentValue     = props.value
			var shouldAddCurrent = props.validateTag(currentValue)

			var state   = this.state
			var value

			var allTags = []
			var tags    = this.tags
			var i       = 0
			var len     = tags.length

			var activeTagIndex = state.activeTagIndex
			var tag

			if (props.editableTags){

				var addCurrentValue
				var addCurrentTag

				for (; i < len; i++){
					tag = tags[i]

					addCurrentValue = i == activeTagIndex
					addCurrentTag   = i != index

					if (addCurrentValue){
						shouldAddCurrent && allTags.push(currentValue)
					}
					if (addCurrentTag){
						allTags.push(tag)
					} else {
						value = tag
					}
				}

				if (activeTagIndex == -1){
					shouldAddCurrent && allTags.push(currentValue)
				} else {
					if (shouldAddCurrent && index >= activeTagIndex){
						//the current value was added
						index++
					}
				}
			} else {
				allTags = tags
				value = currentValue
			}

			if (index >= allTags.length){
				index = -1
			}
			if (index < 0){
				index = -1
			}

			this.setState({
				activeTagIndex: index
			}, callback || emptyFn)

			this.notifyChange(props, value, allTags)
		},

		prepareProps: function(thisProps, state) {
			var props = assign({}, thisProps)

			if (props.selectableTags){
				props.editableTags = false
			}

			this.prepareStyles(props, state)

			props.tagStyle       = this.prepareTagStyle(props, state)
			props.tags           = this.tags = this.prepareTags(props)
			props.value          = this.prepareValue(props, state)
			props.renderChildren = this.renderChildren.bind(this, props)

			props.onChange  = this.handleChange.bind(this, props)
			props.onBlur    = this.handleBlur.bind(this, props)
			props.onKeyDown = this.handleKeyDown.bind(this, props)
			props.onClick   = this.handleClick.bind(this, props)

			props.focusOnClick = false

			return props
		},

		prepareStyles: function(props, state) {
			props.style = this.prepareStyle(props, state)
			props.innerStyle = assign({}, props.defaultInnerStyle, props.innerStyle)
			props.inputStyle = assign({}, props.defaultInputStyle, props.inputStyle)

			props.tagClearToolStyle = this.prepareTagClearToolStyle(props, state)


			delete props.defaultStyle
			delete props.defaultInnerStyle
			delete props.defaultInputStyle
		},

		prepareTagClearToolStyle: function(props, state) {
			var style = assign({}, props.defaultTagClearToolStyle, {
				color: props.tagClearToolColor
			}, props.tagClearToolStyle)

			return style
		},

		prepareStyle: function(props) {
			var style = assign({}, props.defaultStyle, props.style)

			return style
		},

		prepareValue: function(props, state) {
		    return this.getValue()
		},

		prepareTags: function(props) {
			var tags  = props.tags
			var state = this.state

			if (tags == null){
				tags = state.defaultTags
			}

			tags = Array.isArray(tags) && tags.length? [].concat(tags): []

			return tags.filter(props.validateTag)
		},

		prepareTagStyle: function(props, state) {
			return assign({}, props.defaultTagStyle, props.tagStyle)
		},

		renderChildren: function(props, children) {
			var result = children
			var state = this.state

			var tags = props.tags

			if (tags.length){
				tags = tags.map(function(tag, index){
					return this.renderTag(props, tag, index)
				}, this)

				if (state.activeTagIndex == -1 || !props.editableTags){
					result = tags.concat(children)
				} else {
					result = tags.slice(0, state.activeTagIndex)
								.concat(children)
								.concat(tags.slice(state.activeTagIndex))
				}
			}

			result.push(this.renderHiddenField(props))

			return result
		},

		renderHiddenField: function(props) {
			if (props.editableTags){
				return
			}

			return React.createElement("input", {
				key: "hiddenFocusField", 
				type: "text", 
				ref: "hiddenFocusField", 
				onFocus: this.onHiddenFocus, 
				onKeyDown: this.onHiddenKeyDown.bind(this, props), 
				style: {
					opacity: 0,
					width: 0,
					height: 0,
					margin: 0,
					boxSizing: 'border-box',
					border: 0
					// visibility: 'hidden'
				}}
			)
		},

		onHiddenKeyDown: function(props, event){

			event.preventDefault()
			event.stopPropagation()

			var tags = this.tags
			var len = tags.length
			var activeTagIndex = this.state.activeTagIndex

			if (!len){
				return
			}

			var key = event.key

			var dir

			if (key == 'ArrowLeft'){
				dir = -1
			}
			if (key == 'ArrowRight'){
				dir = 1
			}

			var newIndex

			if (dir){
				newIndex = activeTagIndex + dir

				if (newIndex < 0){
					newIndex = len - 1
				}

				if (newIndex >= len){
					newIndex = 0
				}
				this.setActiveTagIndex(props, newIndex)

			} else {

				if (key == 'Delete' || key == 'Backspace'){
					this.removeTag(props, activeTagIndex)

					if (key == 'Backspace' || activeTagIndex === len - 1){
						newIndex = activeTagIndex - 1
						if (newIndex < 0){
							newIndex = 0
						}
						setTimeout(function(){
							this.setActiveTagIndex(props, newIndex)
						}.bind(this), 0)
					}

					if (len == 1){
						this.focus()
					}
				}

				if (key == 'Escape'){
					this.setActiveTagIndex(props, -1)
					this.focus()
					return
				}
			}
		},

		focusHidden: function() {
			this.getFocusField().getDOMNode().focus()
		},

		getFocusField: function(){
			return this.refs.field.refs.hiddenFocusField
		},

		renderTag: function(props, tag, index) {
			var state = this.state
			var tool
			var tagClearTool = props.tagClearTool

			if (tagClearTool){
				if (typeof tagClearTool == 'function'){
					tool = tagClearTool()
				} else {
					tool = React.createElement("span", {style: props.tagClearToolStyle, onClick: this.onTagClearClick.bind(this, props, tag, index)}, "✖")
				}
			}

			var tagStyle = props.tagStyle
			var selectedIndex = state.activeTagIndex

			if (props.selectableTags && index == selectedIndex){
				tagStyle = assign({}, tagStyle, props.selectedTagStyle)
			}

			return React.createElement("span", {key: index, style: tagStyle, onMouseDown: preventDefault, onClick: this.onTagClick.bind(this, props, tag, index)}, 
				tag, 
				tool
			)
		},

		onTagClick: function(props, tag, index, event) {
			if (event.nativeEvent.clearTag){
				return
			}

			if (props.selectableTags){
				this.focusHidden()
				// return
			}

			event.nativeEvent.tagClick = true

			this.setActiveTagIndex(props, index)
		},

		onTagClearClick: function(props, tag, index, event){
			event.nativeEvent.clearTag = true
			this.removeTag(props, index)
		},

		notify: function(value, event) {
		    var field = this.refs.field

		    field.notify(value, event)
		},

		focus: function(value, event) {
		    this.refs.field.focus()
		}
	})

/***/ },
/* 3 */
/***/ function(module, exports, __webpack_require__) {

	/* WEBPACK VAR INJECTION */(function(global) {'use strict';

	var document = global.document

	//from http://javascript.nwbox.com/cursor_position/, but added the !window.getSelection check, which
	//is needed for newer versions of IE, which adhere to standards
	module.exports = function getSelectionStart(o) {
	    if (o.createTextRange && !window.getSelection) {
	        var r = document.selection.createRange().duplicate()
	        r.moveEnd('character', o.value.length)
	        if (r.text == '') return o.value.length
	        return o.value.lastIndexOf(r.text)
	    } else return o.selectionStart
	}
	
	/* WEBPACK VAR INJECTION */}.call(exports, (function() { return this; }())))

/***/ },
/* 4 */
/***/ function(module, exports, __webpack_require__) {

	/* WEBPACK VAR INJECTION */(function(global) {'use strict';

	var document = global.document

	module.exports = function getSelectionEnd(o) {
	    if (o.createTextRange && !window.getSelection) {
	        var r = document.selection.createRange().duplicate()
	        r.moveStart('character', -o.value.length)
	        return r.text.length
	    } else return o.selectionEnd
	}
	/* WEBPACK VAR INJECTION */}.call(exports, (function() { return this; }())))

/***/ },
/* 5 */
/***/ function(module, exports, __webpack_require__) {

	/* WEBPACK VAR INJECTION */(function(global) {'use strict';

	var document = global.document

	module.exports = function(o, range) {
		var start = range.start
		var end = range.end

		if (o.setSelectionRange == 'function'){
			o.setSelectionRange(start, end )
		} else {
	    	o.selectionStart = start
	    	o.selectionEnd = end
	    }
	}
	
	/* WEBPACK VAR INJECTION */}.call(exports, (function() { return this; }())))

/***/ },
/* 6 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';

	function ToObject(val) {
		if (val == null) {
			throw new TypeError('Object.assign cannot be called with null or undefined');
		}

		return Object(val);
	}

	module.exports = Object.assign || function (target, source) {
		var from;
		var keys;
		var to = ToObject(target);

		for (var s = 1; s < arguments.length; s++) {
			from = arguments[s];
			keys = Object.keys(Object(from));

			for (var i = 0; i < keys.length; i++) {
				to[keys[i]] = from[keys[i]];
			}
		}

		return to;
	};


/***/ },
/* 7 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';

	var hasOwn      = __webpack_require__(9)
	var getPrefixed = __webpack_require__(10)

	var map      = __webpack_require__(11)
	var plugable = __webpack_require__(12)

	function plugins(key, value){

		var result = {
			key  : key,
			value: value
		}

		;(RESULT.plugins || []).forEach(function(fn){

			var tmp = map(function(res){
				return fn(key, value, res)
			}, result)

			if (tmp){
				result = tmp
			}
		})

		return result
	}

	function normalize(key, value){

		var result = plugins(key, value)

		return map(function(result){
			return {
				key  : getPrefixed(result.key, result.value),
				value: result.value
			}
		}, result)

		return result
	}

	var RESULT = function(style){
		var k
		var item
		var result = {}

		for (k in style) if (hasOwn(style, k)){
			item = normalize(k, style[k])

			if (!item){
				continue
			}

			map(function(item){
				result[item.key] = item.value
			}, item)
		}

		return result
	}

	module.exports = plugable(RESULT)

/***/ },
/* 8 */
/***/ function(module, exports, __webpack_require__) {

	/** @jsx React.DOM */'use strict';

	var assign = __webpack_require__(6)
	var React  = __webpack_require__(1)
	var normalize = __webpack_require__(7)

	function emptyFn() {}

	var TOOL_STYLES = {
	    true : {display: 'inline-block'},
	    false: {cursor: 'text', color: 'transparent'}
	}

	var INDEX = 0

	var DESCRIPTOR = {

	    displayName: 'ReactInputField',

	    propTypes: {
	        validate : React.PropTypes.oneOfType([
	            React.PropTypes.func,
	            React.PropTypes.bool
	        ]),
	        isEmpty  : React.PropTypes.func,
	        clearTool: React.PropTypes.bool
	    },

	    getInitialState: function(){
	        return {
	            defaultValue: this.props.defaultValue
	        }
	    },

	    getDefaultProps: function () {
	        return {
	            focusOnClick: true,

	            defaultClearToolStyle: {
	                fontSize   : 20,
	                paddingRight: 5,
	                paddingLeft : 5,

	                alignSelf  : 'center',
	                cursor     : 'pointer',
	                userSelect : 'none',
	                boxSizing: 'border-box'
	            },
	            clearToolColor    : '#a8a8a8',
	            clearToolOverColor: '#7F7C7C',
	            defaultStyle: {
	                border    : '1px solid #a8a8a8',
	                boxSizing : 'border-box'
	                // ,
	                // height    : 30
	            },

	            defaultInnerStyle: {
	                userSelect: 'none',
	                width     : '100%',
	                display   : 'inline-flex',
	                flexFlow  : 'row',
	                alignItems: 'stretch'
	            },

	            defaultInvalidStyle: {
	                border : '1px solid rgb(248, 144, 144)'
	            },

	            defaultInputStyle: {
	                flex   : 1,
	                border : 0,
	                height : '100%',
	                padding: '6px 2px',
	                outline: 'none',
	                boxSizing: 'border-box'
	            },

	            defaultInputInvalidStyle: {

	            },

	            emptyValue: '',
	            inputClassName: '',
	            inputProps    : null,

	            clearTool: true,

	            defaultClassName: 'z-field',
	            emptyClassName  : 'z-empty-value',
	            invalidClassName: 'z-invalid',

	            toolsPosition: 'right'
	        }
	    },

	    render: function() {

	        if (this.valid === undefined){
	            this.valid = true
	        }

	        var props = this.prepareProps(this.props, this.state)

	        if (this.valid !== props.valid && typeof props.onValidityChange === 'function'){
	            setTimeout(function(){
	                props.onValidityChange(props.valid, props.value, props)
	            }, 0)
	        }

	        this.valid = props.valid

	        var children = this.renderChildren(props, this.state)

	        // delete props.value

	        var divProps = assign({}, props)
	        delete divProps.value
	        delete divProps.placeholder

	        return React.createElement("div", React.__spread({},  divProps), 
	            React.createElement("div", {style: props.innerStyle}, 
	                children
	            )
	        )
	    },

	    renderChildren: function(props, state){
	        var field = this.renderField(props, state)
	        var tools = this.renderTools(props, state)

	        var children = [field, props.children]

	        if (props.toolsPosition == 'after' || props.toolsPosition == 'right'){
	            children.push.apply(children, tools)
	        } else {
	            children = (tools || []).concat(field)
	        }

	        if (typeof props.renderChildren == 'function'){
	            children = props.renderChildren(children)
	        }

	        return children
	    },

	    renderField: function(props) {
	        var inputProps = this.prepareInputProps(props)

	        inputProps.ref = 'input'

	        if (props.inputFactory){
	            return props.inputFactory(inputProps, props)
	        }

	        return React.createElement("input", React.__spread({},  inputProps))
	    },

	    renderTools: function(props, state) {

	        var clearTool = this.renderClearTool(props, state)
	        var result    = [clearTool]

	        if (typeof props.tools === 'function'){
	            result = props.tools(props, clearTool)
	        }

	        return result
	    },

	    renderClearTool: function(props, state) {

	        if (!props.clearTool || props.readOnly || props.disabled){
	            return
	        }

	        var visible         = !this.isEmpty(props)
	        var visibilityStyle = TOOL_STYLES[visible]
	        var style           = assign({}, visibilityStyle, this.prepareClearToolStyle(props, state))

	        if (!visible){
	            assign(style, visibilityStyle)
	        }

	        return React.createElement("div", {
	            key: "clearTool", 
	            className: "z-clear-tool", 
	            onClick: this.handleClearToolClick, 
	            onMouseDown: this.handleClearToolMouseDown, 
	            onMouseOver: this.handleClearToolOver, 
	            onMouseOut: this.handleClearToolOut, 
	            style: style
	        }, "✖")
	    },

	    handleClearToolMouseDown: function(event) {
	        event.preventDefault()
	    },

	    handleClearToolOver: function(){
	        this.setState({
	            clearToolOver: true
	        })
	    },

	    handleClearToolOut: function(){
	        this.setState({
	            clearToolOver: false
	        })
	    },

	    isEmpty: function(props) {
	        var emptyValue = this.getEmptyValue(props)

	        if (typeof props.isEmpty === 'function'){
	            return props.isEmpty(props, emptyValue)
	        }

	        var value = props.value

	        if (value == null){
	            value = ''
	        }

	        return value === emptyValue
	    },

	    getEmptyValue: function(props){
	        var value = props.emptyValue

	        if (typeof value === 'function'){
	            value = value(props)
	        }

	        return value
	    },

	    isValid: function(props) {
	        var value = props.value
	        var result = true

	        if (typeof props.validate === 'function'){
	            result = props.validate(value, props) !== false
	        }

	        return result
	    },

	    getInput: function() {
	        return this.refs.input.getDOMNode()
	    },

	    focus: function(){
	        var input = this.getInput()

	        if (input && typeof input.focus === 'function'){
	            input.focus()
	        }
	    },

	    handleClick: function(event){
	        if (this.props.focusOnClick && !this.isFocused()){
	            this.focus()
	        }
	    },

	    handleMouseDown: function(event) {
	        ;(this.props.onMouseDown || emptyFn)(event)
	        // event.preventDefault()
	    },

	    handleClearToolClick: function(event) {
	        this.notify(this.getEmptyValue(this.props), event)
	    },

	    handleChange: function(event) {
	        event.stopPropagation()
	        this.notify(event.target.value, event)
	    },

	    handleSelect: function(event) {
	        event.stopPropagation()
	        ;(this.props.onSelect || emptyFn)(event)
	    },

	    notify: function(value, event) {
	        if (this.props.value === undefined){
	            this.setState({
	                defaultValue: value
	            })
	        }
	        ;(this.props.onChange || emptyFn)(value, this.props, event)
	    },

	    //*****************//
	    // PREPARE METHODS //
	    //*****************//
	    prepareProps: function(thisProps, state) {

	        var props = {}

	        assign(props, thisProps)

	        props.value = this.prepareValue(props, state)
	        props.valid = this.isValid(props)
	        props.onClick = this.handleClick
	        props.onMouseDown = this.handleMouseDown

	        props.className = this.prepareClassName(props)
	        props.style = this.prepareStyle(props)
	        props.innerStyle = this.prepareInnerStyle(props)

	        return props
	    },

	    getValue: function() {
	        var value = this.props.value === undefined?
	                        this.state.defaultValue:
	                        this.props.value

	        return value
	    },

	    prepareValue: function(props, state) {
	        return this.getValue()
	    },

	    prepareClassName: function(props) {
	        var result = [props.className, props.defaultClassName]

	        if (this.isEmpty(props)){
	            result.push(props.emptyClassName)
	        }

	        if (!props.valid){
	            result.push(props.invalidClassName)
	        }

	        return result.join(' ')
	    },

	    prepareStyle: function(props) {
	        var style = assign({}, props.defaultStyle, props.style)

	        if (!props.valid){
	            assign(style, props.defaultInvalidStyle, props.invalidStyle)
	        }

	        return style
	    },

	    prepareInnerStyle: function(props) {
	        var style = assign({}, props.defaultInnerStyle, props.innerStyle)

	        return normalize(style)
	    },

	    prepareInputProps: function(props) {

	        var inputProps = {
	            className: props.inputClassName
	        }

	        assign(inputProps, props.defaultInputProps, props.inputProps)

	        inputProps.key         = 'field'
	        inputProps.value       = props.value
	        inputProps.placeholder = props.placeholder
	        inputProps.onChange    = this.handleChange
	        inputProps.onSelect    = this.handleSelect
	        inputProps.style       = this.prepareInputStyle(props)
	        inputProps.onFocus     = this.handleFocus
	        inputProps.onBlur      = this.handleBlur
	        inputProps.name        = props.name
	        inputProps.disabled    = props.disabled
	        inputProps.readOnly    = props.readOnly

	        return inputProps
	    },

	    handleFocus: function(){
	        this._focused = true
	    },

	    handleBlur: function(){
	        this._focused = false
	    },

	    isFocused: function(){
	        return !!this._focused
	    },

	    prepareInputStyle: function(props) {
	        var inputStyle = props.inputProps?
	                            props.inputProps.style:
	                            null

	        var style = assign({}, props.defaultInputStyle, props.inputStyle, inputStyle)

	        if (!props.valid){
	            assign(style, props.defaultInputInvalidStyle, props.inputInvalidStyle)
	        }

	        return normalize(style)
	    },

	    prepareClearToolStyle: function(props, state) {
	        var defaultClearToolOverStyle
	        var clearToolOverStyle
	        var clearToolColor

	        if (state && state.clearToolOver){
	            defaultClearToolOverStyle = props.defaultClearToolOverStyle
	            clearToolOverStyle = props.clearToolOverStyle
	        }

	        if (props.clearToolColor){
	            clearToolColor = {
	                color: props.clearToolColor
	            }
	            if (state && state.clearToolOver && props.clearToolOverColor){
	                clearToolColor = {
	                    color: props.clearToolOverColor
	                }
	            }
	        }

	        var style = assign(
	                        {},
	                        props.defaultClearToolStyle,
	                        defaultClearToolOverStyle,
	                        clearToolColor,
	                        props.clearToolStyle,
	                        clearToolOverStyle
	                    )

	        return style
	    }
	}

	var ReactClass = React.createClass(DESCRIPTOR)

	ReactClass.descriptor = DESCRIPTOR

	module.exports = ReactClass

/***/ },
/* 9 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';

	module.exports = function(obj, prop){
		return Object.prototype.hasOwnProperty.call(obj, prop)
	}


/***/ },
/* 10 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';

	var getStylePrefixed = __webpack_require__(13)
	var properties       = __webpack_require__(14)

	module.exports = function(key, value){

		if (!properties[key]){
			return key
		}

		return getStylePrefixed(key, value)
	}

/***/ },
/* 11 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';

	module.exports = function(fn, item){

		if (!item){
			return
		}

		if (Array.isArray(item)){
			return item.map(fn).filter(function(x){
				return !!x
			})
		} else {
			return fn(item)
		}
	}

/***/ },
/* 12 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';

	var getCssPrefixedValue = __webpack_require__(15)

	module.exports = function(target){
		target.plugins = target.plugins || [
			(function(){
				var values = {
					'flex':1,
					'inline-flex':1
				}

				return function(key, value){
					if (key === 'display' && value in values){
						return {
							key  : key,
							value: getCssPrefixedValue(key, value)
						}
					}
				}
			})()
		]

		target.plugin = function(fn){
			target.plugins = target.plugins || []

			target.plugins.push(fn)
		}

		return target
	}

/***/ },
/* 13 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';

	var toUpperFirst = __webpack_require__(16)
	var getPrefix    = __webpack_require__(17)
	var el           = __webpack_require__(18)

	var MEMORY = {}
	var STYLE = el.style

	module.exports = function(key, value){

	    var k = key// + ': ' + value

	    if (MEMORY[k]){
	        return MEMORY[k]
	    }

	    var prefix
	    var prefixed

	    if (!(key in STYLE)){//we have to prefix

	        prefix = getPrefix('appearance')

	        if (prefix){
	            prefixed = prefix + toUpperFirst(key)

	            if (prefixed in STYLE){
	                key = prefixed
	            }
	        }
	    }

	    MEMORY[k] = key

	    return key
	}

/***/ },
/* 14 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';

	module.exports = {
	  'alignItems': 1,
	  'justifyContent': 1,
	  'flex': 1,
	  'flexFlow': 1,

	  'userSelect': 1,
	  'transform': 1,
	  'transition': 1,
	  'transformOrigin': 1,
	  'transformStyle': 1,
	  'transitionProperty': 1,
	  'transitionDuration': 1,
	  'transitionTimingFunction': 1,
	  'transitionDelay': 1,
	  'borderImage': 1,
	  'borderImageSlice': 1,
	  'boxShadow': 1,
	  'backgroundClip': 1,
	  'backfaceVisibility': 1,
	  'perspective': 1,
	  'perspectiveOrigin': 1,
	  'animation': 1,
	  'animationDuration': 1,
	  'animationName': 1,
	  'animationDelay': 1,
	  'animationDirection': 1,
	  'animationIterationCount': 1,
	  'animationTimingFunction': 1,
	  'animationPlayState': 1,
	  'animationFillMode': 1,
	  'appearance': 1
	}

/***/ },
/* 15 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';

	var getPrefix     = __webpack_require__(17)
	var forcePrefixed = __webpack_require__(19)
	var el            = __webpack_require__(18)

	var MEMORY = {}
	var STYLE = el.style

	module.exports = function(key, value){

	    var k = key + ': ' + value

	    if (MEMORY[k]){
	        return MEMORY[k]
	    }

	    var prefix
	    var prefixed
	    var prefixedValue

	    if (!(key in STYLE)){

	        prefix = getPrefix('appearance')

	        if (prefix){
	            prefixed = forcePrefixed(key, value)

	            prefixedValue = '-' + prefix.toLowerCase() + '-' + value

	            if (prefixed in STYLE){
	                el.style[prefixed] = ''
	                el.style[prefixed] = prefixedValue

	                if (el.style[prefixed] !== ''){
	                    value = prefixedValue
	                }
	            }
	        }
	    }

	    MEMORY[k] = value

	    return value
	}

/***/ },
/* 16 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';

	module.exports = function(str){
		return str?
				str.charAt(0).toUpperCase() + str.slice(1):
				''
	}

/***/ },
/* 17 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';

	var toUpperFirst = __webpack_require__(16)
	var prefixes     = ["ms", "Moz", "Webkit", "O"]

	var el = __webpack_require__(18)

	var PREFIX

	module.exports = function(key){

		if (PREFIX){
			return PREFIX
		}

		var i = 0
		var len = prefixes.length
		var tmp
		var prefix

		for (; i < len; i++){
			prefix = prefixes[i]
			tmp = prefix + toUpperFirst(key)

			if (typeof el.style[tmp] != 'undefined'){
				return PREFIX = prefix
			}
		}
	}

/***/ },
/* 18 */
/***/ function(module, exports, __webpack_require__) {

	/* WEBPACK VAR INJECTION */(function(global) {'use strict';

	var el

	if(!!global.document){
	  	el = global.document.createElement('div')
	}

	module.exports = el
	/* WEBPACK VAR INJECTION */}.call(exports, (function() { return this; }())))

/***/ },
/* 19 */
/***/ function(module, exports, __webpack_require__) {

	'use strict';

	var toUpperFirst = __webpack_require__(16)
	var getPrefix    = __webpack_require__(17)
	var properties   = __webpack_require__(14)

	/**
	 * Returns the given key prefixed, if the property is found in the prefixProps map.
	 *
	 * Does not test if the property supports the given value unprefixed.
	 * If you need this, use './getPrefixed' instead
	 */
	module.exports = function(key, value){

		if (!properties[key]){
			return key
		}

		var prefix = getPrefix(key)

		return prefix?
					prefix + toUpperFirst(key):
					key
	}

/***/ }
/******/ ])
});
